@extends('layout')

@section('title')
  <title> Zonal Round 5 Score Sheet </title>
@stop

@section('css')
<style>
th{
  font-weight:bold;
  font-size:18px;
}
td{
  font-size:15px;
}
td a.edit {
    color: #FFC107;
}
td a.delete {
    color: #E34724;
}
.modal-ku {
  width: 750px;
  margin: auto;
}

</style>
@stop

@section('content')

<br/>
      <h4 class="mb-3">  Zonal Round 5 Score Sheet  </h4>
 <div class="responsive">
 
 <div class="table-responsive table-mobview">          
  <table class="table">
     <?php $sno=1; ?>
    <thead>
      <tr style="color:red;">
      <th>S No.</th>
      <th>Team Name</th>
      <th> RF 1 </th>
      <th> RF 2 </th>
      <th> RF 3 </th>
      <th> RF 4 </th>
      <th> RF 5 </th>
      <th></th>
      </tr>
    </thead>
    @foreach($teams as $t)
    <form class="rf_frm"  action="{{ url('/zonalround4scoresheet/'.$t->team_id) }}"  method="post">
    <tbody>  
      
      <tr class="p-3 mb-2">
        <td data-label="S No.">{{ $sno++}} </td>
         <td data-label="Team Name">{{ $t->team_name }} </td>
         <td data-label="">
            {{ Form::select('ddlmarks',$zoom_marks,isset($zoom_marks->marks) ? $zoom_marks->zoom_marks:'',array('id'=>'ddlmarks1_'.$t->team_id,'class' => 'ddlmarks1 form-control input-md','data-team-id'=>$t->team_id)) }}<br/>
            <input class="form-control input_txt" type="numeric" name="rf1_txt" id="dvrf1_{{$t->team_id}}" data-team-id="{{ $t->team_id}}" data-rf-no="1" style="display: none" value="{{$t->rf1}}" />
         </td>
          <td data-label="">
            {{ Form::select('ddlmarks',$zoom_marks,isset($zoom_marks->marks) ? $zoom_marks->zoom_marks:'',array('id'=>'ddlmarks2_'.$t->team_id,'class' => 'ddlmarks2 form-control input-md','data-team-id'=>$t->team_id)) }}<br/>
            <input class="form-control input_txt" type="numeric" name="rf2_txt" id="dvrf2_{{$t->team_id}}" data-team-id="{{ $t->team_id}}" data-rf-no="2" style="display: none" value="{{$t->rf2}}" />
         </td>
          <td data-label="">
            {{ Form::select('ddlmarks',$zoom_marks,isset($zoom_marks->marks) ? $zoom_marks->zoom_marks:'',array('id'=>'ddlmarks3_'.$t->team_id,'class' => 'ddlmarks3 form-control input-md','data-team-id'=>$t->team_id)) }}<br/>
            <input class="form-control input_txt" type="numeric" name="rf3_txt" id="dvrf3_{{$t->team_id}}"  data-team-id="{{ $t->team_id}}" data-rf-no="3" style="display: none" value="{{$t->rf3}}" />
         </td>
          <td data-label="">
            {{ Form::select('ddlmarks',$zoom_marks,isset($zoom_marks->marks) ? $zoom_marks->zoom_marks:'',array('id'=>'ddlmarks4_'.$t->team_id,'class' => 'ddlmarks4 form-control input-md','data-team-id'=>$t->team_id)) }}<br/>
            <input class="form-control input_txt" type="numeric" name="rf4_txt" id="dvrf4_{{$t->team_id}}" data-team-id="{{ $t->team_id}}" data-rf-no="4" style="display: none" value="{{$t->rf4}}" />
         </td>
          <td data-label="">
            {{ Form::select('ddlmarks',$zoom_marks,isset($zoom_marks->marks) ? $zoom_marks->zoom_marks:'',array('id'=>'ddlmarks5_'.$t->team_id,'class' => 'ddlmarks5 form-control input-md','data-team-id'=>$t->team_id)) }}<br/>
            <input class="form-control input_txt" type="numeric" name="rf5_txt" id="dvrf5_{{$t->team_id}}" data-team-id="{{ $t->team_id}}" data-rf-no="5" style="display: none" value="{{$t->rf5}}" />
         </td>
         <td>
         @if(isset($t->rf5))
          <button type="submit" id="btnNext" name="update" class="btn btn-success float-right">Update</button>
          @else
          <button type="submit" id="btnNext" name="save" class="btn btn-primary float-right">Save</button>
          @endif
        </td>
      </tr>
    </tbody>
    </form>
    @endforeach 
  </table>
</div>

</div>
<script type="text/javascript">
$( document ).ready(function() {

$('.input_txt').each(function(){
    var text_val = $(this).val();
    var team_id  = $(this).attr('data-team-id')
    var rf_no    = $(this).attr('data-rf-no')
    // alert(team_id);
    if(text_val) 
    {
       $(this).show();
       $("#ddlmarks"+rf_no+"_"+team_id).hide();
    }
    else
    {
       $(this).hide();
       // $("#ddlmarks1_"+team_id).hide();
       // $("#ddlmarks2_"+team_id).hide();
       // $("#ddlmarks3_"+team_id).hide();
       // $("#ddlmarks4_"+team_id).hide();
       // $("#ddlmarks5_"+team_id).hide();
    }
})
      
    $('.ddlmarks1').on('change', function() {
      var team_id =  $(this).attr('data-team-id')
      $("#dvrf1_"+team_id).show();
    });
    $('.ddlmarks2').on('change', function() {
      var team_id =  $(this).attr('data-team-id')
      $("#dvrf2_"+team_id).show();
    });
    $('.ddlmarks3').on('change', function() {
      var team_id =  $(this).attr('data-team-id')
      $("#dvrf3_"+team_id).show();
    });
    $('.ddlmarks4').on('change', function() {
      var team_id =  $(this).attr('data-team-id')
      $("#dvrf4_"+team_id).show();
    });
    $('.ddlmarks5').on('change', function() {
      var team_id =  $(this).attr('data-team-id')
      $("#dvrf5_"+team_id).show();
    });
  });
  
</script> 
@stop

